﻿#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.3082
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace LanSpider.Database
{
	using System.Data.Linq;
	using System.Data.Linq.Mapping;
	using System.Data;
	using System.Collections.Generic;
	using System.Reflection;
	using System.Linq;
	using System.Linq.Expressions;
	using System.ComponentModel;
	using System;
	
	
	[System.Data.Linq.Mapping.DatabaseAttribute(Name="EpamSharesIndex")]
	public partial class Epam_IndexDataContext : System.Data.Linq.DataContext
	{
		
		private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
		
    #region Extensibility Method Definitions
    partial void OnCreated();
    partial void Insertfile(file instance);
    partial void Updatefile(file instance);
    partial void Deletefile(file instance);
    partial void Insertfolder(folder instance);
    partial void Updatefolder(folder instance);
    partial void Deletefolder(folder instance);
    #endregion
		
		public Epam_IndexDataContext() : 
				base(global::LanSpider.Properties.Settings.Default.EpamSharesIndexConnectionString, mappingSource)
		{
			OnCreated();
		}
		
		public Epam_IndexDataContext(string connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public Epam_IndexDataContext(System.Data.IDbConnection connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public Epam_IndexDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public Epam_IndexDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public System.Data.Linq.Table<file> files
		{
			get
			{
				return this.GetTable<file>();
			}
		}
		
		public System.Data.Linq.Table<folder> folders
		{
			get
			{
				return this.GetTable<folder>();
			}
		}
	}
	
	[Table(Name="dbo.[file]")]
	public partial class file : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _file_id;
		
		private int _parent_folder_id;
		
		private string _name;
		
		private string _type;
		
		private long _size;
		
		private System.DateTime _indexed_on;
		
		private EntityRef<folder> _folder;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void Onfile_idChanging(int value);
    partial void Onfile_idChanged();
    partial void Onparent_folder_idChanging(int value);
    partial void Onparent_folder_idChanged();
    partial void OnnameChanging(string value);
    partial void OnnameChanged();
    partial void OntypeChanging(string value);
    partial void OntypeChanged();
    partial void OnsizeChanging(long value);
    partial void OnsizeChanged();
    partial void Onindexed_onChanging(System.DateTime value);
    partial void Onindexed_onChanged();
    #endregion
		
		public file()
		{
			this._folder = default(EntityRef<folder>);
			OnCreated();
		}
		
		[Column(Storage="_file_id", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int file_id
		{
			get
			{
				return this._file_id;
			}
			set
			{
				if ((this._file_id != value))
				{
					this.Onfile_idChanging(value);
					this.SendPropertyChanging();
					this._file_id = value;
					this.SendPropertyChanged("file_id");
					this.Onfile_idChanged();
				}
			}
		}
		
		[Column(Storage="_parent_folder_id", DbType="Int NOT NULL")]
		public int parent_folder_id
		{
			get
			{
				return this._parent_folder_id;
			}
			set
			{
				if ((this._parent_folder_id != value))
				{
					if (this._folder.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.Onparent_folder_idChanging(value);
					this.SendPropertyChanging();
					this._parent_folder_id = value;
					this.SendPropertyChanged("parent_folder_id");
					this.Onparent_folder_idChanged();
				}
			}
		}
		
		[Column(Storage="_name", DbType="NVarChar(255)")]
		public string name
		{
			get
			{
				return this._name;
			}
			set
			{
				if ((this._name != value))
				{
					this.OnnameChanging(value);
					this.SendPropertyChanging();
					this._name = value;
					this.SendPropertyChanged("name");
					this.OnnameChanged();
				}
			}
		}
		
		[Column(Storage="_type", DbType="VarChar(250)")]
		public string type
		{
			get
			{
				return this._type;
			}
			set
			{
				if ((this._type != value))
				{
					this.OntypeChanging(value);
					this.SendPropertyChanging();
					this._type = value;
					this.SendPropertyChanged("type");
					this.OntypeChanged();
				}
			}
		}
		
		[Column(Storage="_size", DbType="BigInt NOT NULL")]
		public long size
		{
			get
			{
				return this._size;
			}
			set
			{
				if ((this._size != value))
				{
					this.OnsizeChanging(value);
					this.SendPropertyChanging();
					this._size = value;
					this.SendPropertyChanged("size");
					this.OnsizeChanged();
				}
			}
		}
		
		[Column(Storage="_indexed_on", DbType="DateTime NOT NULL")]
		public System.DateTime indexed_on
		{
			get
			{
				return this._indexed_on;
			}
			set
			{
				if ((this._indexed_on != value))
				{
					this.Onindexed_onChanging(value);
					this.SendPropertyChanging();
					this._indexed_on = value;
					this.SendPropertyChanged("indexed_on");
					this.Onindexed_onChanged();
				}
			}
		}
		
		[Association(Name="folder_file", Storage="_folder", ThisKey="parent_folder_id", OtherKey="folder_id", IsForeignKey=true, DeleteOnNull=true, DeleteRule="CASCADE")]
		public folder folder
		{
			get
			{
				return this._folder.Entity;
			}
			set
			{
				folder previousValue = this._folder.Entity;
				if (((previousValue != value) 
							|| (this._folder.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._folder.Entity = null;
						previousValue.files.Remove(this);
					}
					this._folder.Entity = value;
					if ((value != null))
					{
						value.files.Add(this);
						this._parent_folder_id = value.folder_id;
					}
					else
					{
						this._parent_folder_id = default(int);
					}
					this.SendPropertyChanged("folder");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[Table(Name="dbo.folder")]
	public partial class folder : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _folder_id;
		
		private System.Nullable<int> _parent_id;
		
		private string _path;
		
		private System.DateTime _indexed_on;
		
		private EntitySet<file> _files;
		
		private EntitySet<folder> _folders;
		
		private EntityRef<folder> _folder1;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void Onfolder_idChanging(int value);
    partial void Onfolder_idChanged();
    partial void Onparent_idChanging(System.Nullable<int> value);
    partial void Onparent_idChanged();
    partial void OnpathChanging(string value);
    partial void OnpathChanged();
    partial void Onindexed_onChanging(System.DateTime value);
    partial void Onindexed_onChanged();
    #endregion
		
		public folder()
		{
			this._files = new EntitySet<file>(new Action<file>(this.attach_files), new Action<file>(this.detach_files));
			this._folders = new EntitySet<folder>(new Action<folder>(this.attach_folders), new Action<folder>(this.detach_folders));
			this._folder1 = default(EntityRef<folder>);
			OnCreated();
		}
		
		[Column(Storage="_folder_id", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int folder_id
		{
			get
			{
				return this._folder_id;
			}
			set
			{
				if ((this._folder_id != value))
				{
					this.Onfolder_idChanging(value);
					this.SendPropertyChanging();
					this._folder_id = value;
					this.SendPropertyChanged("folder_id");
					this.Onfolder_idChanged();
				}
			}
		}
		
		[Column(Storage="_parent_id", DbType="Int")]
		public System.Nullable<int> parent_id
		{
			get
			{
				return this._parent_id;
			}
			set
			{
				if ((this._parent_id != value))
				{
					if (this._folder1.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.Onparent_idChanging(value);
					this.SendPropertyChanging();
					this._parent_id = value;
					this.SendPropertyChanged("parent_id");
					this.Onparent_idChanged();
				}
			}
		}
		
		[Column(Storage="_path", DbType="NVarChar(266) NOT NULL", CanBeNull=false)]
		public string path
		{
			get
			{
				return this._path;
			}
			set
			{
				if ((this._path != value))
				{
					this.OnpathChanging(value);
					this.SendPropertyChanging();
					this._path = value;
					this.SendPropertyChanged("path");
					this.OnpathChanged();
				}
			}
		}
		
		[Column(Storage="_indexed_on", DbType="DateTime NOT NULL")]
		public System.DateTime indexed_on
		{
			get
			{
				return this._indexed_on;
			}
			set
			{
				if ((this._indexed_on != value))
				{
					this.Onindexed_onChanging(value);
					this.SendPropertyChanging();
					this._indexed_on = value;
					this.SendPropertyChanged("indexed_on");
					this.Onindexed_onChanged();
				}
			}
		}
		
		[Association(Name="folder_file", Storage="_files", ThisKey="folder_id", OtherKey="parent_folder_id")]
		public EntitySet<file> files
		{
			get
			{
				return this._files;
			}
			set
			{
				this._files.Assign(value);
			}
		}
		
		[Association(Name="folder_folder", Storage="_folders", ThisKey="folder_id", OtherKey="parent_id")]
		public EntitySet<folder> folders
		{
			get
			{
				return this._folders;
			}
			set
			{
				this._folders.Assign(value);
			}
		}
		
		[Association(Name="folder_folder", Storage="_folder1", ThisKey="parent_id", OtherKey="folder_id", IsForeignKey=true)]
		public folder folder1
		{
			get
			{
				return this._folder1.Entity;
			}
			set
			{
				folder previousValue = this._folder1.Entity;
				if (((previousValue != value) 
							|| (this._folder1.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._folder1.Entity = null;
						previousValue.folders.Remove(this);
					}
					this._folder1.Entity = value;
					if ((value != null))
					{
						value.folders.Add(this);
						this._parent_id = value.folder_id;
					}
					else
					{
						this._parent_id = default(Nullable<int>);
					}
					this.SendPropertyChanged("folder1");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_files(file entity)
		{
			this.SendPropertyChanging();
			entity.folder = this;
		}
		
		private void detach_files(file entity)
		{
			this.SendPropertyChanging();
			entity.folder = null;
		}
		
		private void attach_folders(folder entity)
		{
			this.SendPropertyChanging();
			entity.folder1 = this;
		}
		
		private void detach_folders(folder entity)
		{
			this.SendPropertyChanging();
			entity.folder1 = null;
		}
	}
}
#pragma warning restore 1591
